"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.buildCodeByPath = void 0;
const findBindings_1 = require("./findBindings");
function getPathsByBindings(bindings) {
    const paths = new Set();
    for (const x of bindings.keys()) {
        if (x.path.isImportSpecifier() || x.path.isVariableDeclarator()) {
            paths.add(x.path.parentPath);
            continue;
        }
        paths.add(x.path);
    }
    return paths;
}
function buildCodeByPath(path) {
    return Array.from(getPathsByBindings((0, findBindings_1.findBindings)(path, { throwError: true })))
        .sort((a, b) => a.node.start - b.node.start)
        .map((x) => x.toString())
        .join('\n');
}
exports.buildCodeByPath = buildCodeByPath;
//# sourceMappingURL=buildCodeByPath.js.map