"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.mergeObjects = exports.mergeObjectProperties = void 0;
const tslib_1 = require("tslib");
const t = tslib_1.__importStar(require("@babel/types"));
function mergeObjectProperties(properties) {
    const map = new Map();
    function move(key, value) {
        map.delete(key);
        map.set(key, value);
    }
    for (const x of properties) {
        if (!t.isObjectProperty(x)) {
            move(x, x);
            continue;
        }
        const { key } = x;
        if (t.isIdentifier(key)) {
            move(key.name, x);
            continue;
        }
        if (t.isStringLiteral(key)) {
            move(key.value, x);
            continue;
        }
        move(x, x);
    }
    // TODO: there was a problem with typescript compiler with the variant [...map.values()]
    return Array.from(map.values());
}
exports.mergeObjectProperties = mergeObjectProperties;
function mergeObjects(objects) {
    const properties = [];
    objects.forEach((obj) => {
        properties.push(...obj.properties);
    });
    return mergeObjectProperties(properties);
}
exports.mergeObjects = mergeObjects;
//# sourceMappingURL=mergeObjectProperties.js.map