"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getSourceMap = exports.convertGeneratorToComment = exports.makeSourceMapGenerator = exports.getGeneratorOpts = exports.SourceMapGenerator = void 0;
const tslib_1 = require("tslib");
// @flow
const source_map_1 = require("source-map");
Object.defineProperty(exports, "SourceMapGenerator", { enumerable: true, get: function () { return source_map_1.SourceMapGenerator; } });
const convert = tslib_1.__importStar(require("convert-source-map"));
function getGeneratorOpts(file) {
    return file.opts.generatorOpts ? file.opts.generatorOpts : file.opts;
}
exports.getGeneratorOpts = getGeneratorOpts;
// export function makeSourceMapGenerator(file) {
//     const generator = new SourceMapGenerator();
//     return generator;
// }
function makeSourceMapGenerator(file) {
    const generatorOpts = getGeneratorOpts(file);
    const filename = generatorOpts.sourceFileName;
    const generator = new source_map_1.SourceMapGenerator({
        file: filename,
        sourceRoot: generatorOpts.sourceRoot,
    });
    // console.log('root', generatorOpts.sourceRoot);
    generator.setSourceContent(filename, file.code);
    return generator;
}
exports.makeSourceMapGenerator = makeSourceMapGenerator;
function convertGeneratorToComment(generator) {
    return convert.fromObject(generator).toComment({ multiline: true });
}
exports.convertGeneratorToComment = convertGeneratorToComment;
function getSourceMap(offset, state) {
    const generator = makeSourceMapGenerator(state.file);
    const generatorOpts = getGeneratorOpts(state.file);
    if (generatorOpts.sourceFileName &&
        generatorOpts.sourceFileName !== 'unknown') {
        generator.addMapping({
            generated: {
                line: 1,
                column: 0,
            },
            source: generatorOpts.sourceFileName,
            original: offset,
        });
        return convert.fromObject(generator).toComment({ multiline: true });
    }
    return '';
}
exports.getSourceMap = getSourceMap;
//# sourceMappingURL=source-maps.js.map