"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.transform = exports.getBabelOptions = exports.resetStyles = exports.getStyles = exports.PACKAGE_NAME = void 0;
const tslib_1 = require("tslib");
const core_1 = require("@babel/core");
const common_tags_1 = require("common-tags");
const taddy_1 = require("taddy");
const plugin_1 = tslib_1.__importDefault(require("../plugin"));
var config_1 = require("../config");
Object.defineProperty(exports, "PACKAGE_NAME", { enumerable: true, get: function () { return config_1.PACKAGE_NAME; } });
function getStyles() {
    return [...taddy_1.$css.ruleInjector.styleSheet.rules]
        .map((rule) => rule.cssText)
        .join('\n');
}
exports.getStyles = getStyles;
function resetStyles() {
    if (taddy_1.$css.ruleInjector.styleSheet instanceof taddy_1.StyleSheet) {
        taddy_1.$css.ruleInjector.styleSheet.node.remove();
    }
    taddy_1.$css.ruleInjector.reset();
}
exports.resetStyles = resetStyles;
const getBabelOptions = (options = {}) => ({
    filename: `test.virtual.tsx`,
    babelrc: false,
    configFile: false,
    plugins: [
        ['@babel/plugin-syntax-typescript', { isTSX: true }],
        (0, core_1.createConfigItem)((babel) => (0, plugin_1.default)(babel, {
            compileOptions: {
                evaluate: false,
                unstable_typescript: false,
                ...options.compileOptions,
            },
            outputOptions: {
                ...options.outputOptions,
            },
        })),
    ],
});
exports.getBabelOptions = getBabelOptions;
async function transform(code, babelOptions, transformOptions) {
    return (await (0, core_1.transformAsync)((0, common_tags_1.stripIndent)(code), {
        ...(0, exports.getBabelOptions)(babelOptions),
        ...transformOptions,
    }))?.code;
}
exports.transform = transform;
//# sourceMappingURL=common.js.map